do
    local commandThread;

    if(commandThread == nil)then
        commandThread = love.thread.newThread("game/server/commandLineOutputThread.lua")
        commandThread:start()
    end

	local xprint = print
    local function oldPrint(...)
        local Args = {...}
        xprint(unpack(Args))
    end

    function print(...)
        local Args = { ... }
        local outputChannel = nil
        local stat, err = pcall(function()
            outputChannel = love.thread.getChannel("printed-output")
            local succ = outputChannel:supply(Args, 0.05)
            if(succ == false)then
                return error("printing to printing output channel timed out.")
            end
        end)
        if(stat == false)then
            oldPrint(unpack(Args))
            oldPrint("Error printing output through printed-out channel: " .. err)
        end
    end

end